local entity_name = "improved-combinator" -- Replace with your entity name

data:extend({
    {
        type = "item",
        name = entity_name,
        icon = "__ImprovedCombinator__/graphics/icons/improved-combinator-icon.png", -- Updated icon path
        icon_size = 64,
        subgroup = "circuit-network",
        order = "c[combinators]-z["..entity_name.."]",
        stack_size = 50
    },
    {
        type = "container",
        name = entity_name,
        icon = "__ImprovedCombinator__/graphics/icons/improved-combinator-icon.png", -- Updated icon path
        icon_size = 64,
        icon_mipmaps = 4,
        flags = {"not-rotatable", "placeable-neutral", "placeable-player", "player-creation"},
        minable = {hardness = 0.2, mining_time = 2, result = entity_name},
        max_health = 250,
        selection_box = {{-0.75, -0.5}, {0.95, 0.5}},
        collision_box = {{-1.0, -0.35}, {1.0, 0.35}},
        collision_mask = {"item-layer", "object-layer", "water-tile"},
        inventory_size = 0, -- Set inventory size to 0 to disable inventory
        circuit_wire_connection_points = {
            {
                wire = {green = {0, -0.5}, red = {0, 0.5}},
                shadow = {green = {0, -0.5}, red = {0, 0.5}}
            },
            {
                wire = {green = {0, -0.5}, red = {0, 0.5}},
                shadow = {green = {0, -0.5}, red = {0, 0.5}}
            }
        },
        circuit_wire_max_distance = 7.5, -- Adjust as needed
        pictures = {
            layers = {
                {
                    filename = "__ImprovedCombinator__/graphics/entity/improved-combinator-entity.png", -- Updated entity image path
                    priority = "extra-high",
                    width = 102,
                    height = 51,
                    shift = {0, 0},
                    hr_version = {
                        filename = "__ImprovedCombinator__/graphics/entity/hr_improved-combinator-entity.png", -- Updated high-res image path
                        priority = "extra-high",
                        width = 204,
                        height = 102,
                        shift = {0, 0},
                        scale = 0.5
                    }
                }
            }
        }
    }
})
